#========================================================================================
# description  Tests Callback responses from Ogone. AMAZON CHECKOUT TEST IS PENDING
#========================================================================================
use strict;

use Test::More tests => 8;
use Test::MockObject::Extends;

use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Database::API::Connection qw( RunOnStore GetTestSite  );


sub run_tests {
    RunOnStore(
        'Store' => GetTestSite(),
        'Sub'   => sub {
            my $TestedModule  = 'DE_EPAGES::Ogone::UI::Shop';
            my $MockModule = 'DE_EPAGES::Ogone::t::OgoneMock';

            # check accessibility
            use_ok( $TestedModule, 'PaymentCallbackOgone' ) or exit;
            use_ok( $MockModule ) or exit;

            # check instantiation
            my $Mock = $MockModule->new();
            isa_ok($Mock, $MockModule);
            my $OgoneShop = $TestedModule->new('Servlet' => $Mock);
            isa_ok( $OgoneShop, $TestedModule);

            # mock DataBase
            $Mock->initialize_DB();
            ok($Mock->initializeOrderServlet('PaymentCallbackOgone'), 'Servlet mock initialization as a CustomerOrder');

            # run callback and check transacction status
            $TestedModule->PaymentCallbackOgone($Mock);
            is($Mock->getTransactionStatus('CustomerOrder'), 'STATUS_PAID', 'transaction set to PAID by Callback on CustomerOrder');

            ok($Mock->initializeBasketServlet('PaymentCallbackOgone'), 'Servlet mock initialization as a Basket');
            $TestedModule->PaymentCallbackOgone($Mock);

            is($Mock->getTransactionStatus('Basket'), 'STATUS_PAID', 'transaction set to PAID by Callback on Basket');
            # clean DataBase
            $Mock->cleanup_DB();
    });
}

sub Main {
    run_tests();
}

RunScript( 'Sub' => \&Main );

